#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# +-------------------------------------------------------------------
# | 
# +-------------------------------------------------------------------
# | Author: 无依 <756610201@qq.com>
# +-------------------------------------------------------------------

#+--------------------------------------------------------------------
#|   宝塔第三方应用开发
#+--------------------------------------------------------------------
import sys,os,json,re
import sqlite3
#设置运行目录
os.chdir("/www/server/panel")

#添加包引用位置并引用公共包
sys.path.append("class/")
import public

#from common import dict_obj
#get = dict_obj();


#在非命令行模式下引用面板缓存和session对象
if __name__ != '__main__':
    from BTPanel import cache,session,redirect

    #设置缓存(超时10秒) cache.set('key',value,10)
    #获取缓存 cache.get('key')
    #删除缓存 cache.delete('key')

    #设置session:  session['key'] = value
    #获取session:  value = session['key']
    #删除session:  del(session['key'])


class user_auth_main:
    __plugin_path = "/www/server/panel/plugin/user_auth/" # 插件目录
    __config = None
    __DB_CONN = None            # 数据库连接对象
    #构造方法
    def  __init__(self):
        self.__DB_FILE=self.__plugin_path+'auth_user.db'


    def _check(self,args):
        #token = '123456'
        #limit_addr = ['192.168.1.2','192.168.1.3']
        #if args.token != token: return public.returnMsg(False,'Token验证失败!')
        #if not args.client_ip in limit_addr: return public.returnMsg(False,'IP访问受限!')
        #return redirect('/login')
        return True
    # 默认页面
    def index(self,args):
        return self.get_logs(args)
    # 插件开关
    def auth_power(self,args):
        status=0
        msg=''
        if public.FileMd5('/www/server/panel/class/common.py') =='b6477ae4c72ee8404b4484ac31aa63af':
            status=1
        if 'type' in args:
            if args.type=='stop':
                shell_str='/bin/cp -rf /www/server/panel/class/common.py.bak /www/server/panel/class/common.py'
                status=0
            if args.type=='start':
                shell_str='/bin/cp -rf /www/server/panel/plugin/user_auth/templates/common.py /www/server/panel/class/common.py'
                if not os.path.exists('/www/server/panel/class/common.py.bak'):
                    shell_str='/bin/cp -rf /www/server/panel/class/common.py /www/server/panel/class/common.py.bak&&'+shell_str
                status=1
            msg = public.ExecShell(shell_str)
            return {'status':status,'msg':msg}
        return {'status':status,'msg':msg}
    #取用户列表
    def user_list(self,args):
        if not 'p' in args: args.p = 1
        if not 'rows' in args: args.rows = 12
        if not 'callback' in args: args.callback = ''
        args.p = int(args.p)
        args.rows = int(args.rows)
        count = public.M('users').count()
        page_data = public.get_page(count,args.p,args.rows,args.callback)
        user_list = public.M('users').limit(page_data['shift'] + ',' + page_data['row']).field('id,username,login_ip,login_time,phone,email').select()
        user_list_data=[]
        for user in user_list:
            logdata=public.M('logs').order('id desc').where("log LIKE ? and username=?",('%登录成功%',user['username'],)).field('id,uid,username,log,addtime').select()
            if logdata:
                user['login_ip']=re.findall('IP:(.*):', logdata[0]['log'])[0]
                user['login_time']=logdata[0]['addtime']
            user_list_data.append(user)
        #user_list = public.M('users').order('id desc').limit(page_data['shift'] + ',' + page_data['row']).select()
        return {'data': user_list_data,'page':page_data['page'] }
    #重置密码
    def setPassword(self,get):
        if get.password1 != get.password2: return public.returnMsg(False,'USER_PASSWORD_CHECK')
        if len(get.password1) < 5: return public.returnMsg(False,'USER_PASSWORD_LEN')
        public.M('users').where("username=?",(session['username'],)).setField('password',public.password_salt(public.md5(get.password1.strip()),username=session['username']))
        public.WriteLog('TYPE_PANEL','USER_PASSWORD_SUCCESS',(session['username'],))
        self.reload_session()
        return public.returnMsg(True,'USER_PASSWORD_SUCCESS')
    #重置账号   
    def setUsername(self,get):
        if get.username1 != get.username2: return public.returnMsg(False,'USER_USERNAME_CHECK')
        if len(get.username1) < 3: return public.returnMsg(False,'USER_USERNAME_LEN')
        public.M('users').where("username=?",(session['username'],)).setField('username',get.username1.strip())
        public.WriteLog('TYPE_PANEL','USER_USERNAME_SUCCESS',(session['username'],get.username2))
        session['username'] = get.username1
        self.reload_session()
        return public.returnMsg(True,'USER_USERNAME_SUCCESS')    
    #取用户信息
    def get_users(self,args):
        data = public.M('users').field('id,username,phone,email').where('id=?',(args.id,)).find()
        return data
    # 创建新用户
    def create_user(self,args):
        if session['uid'] != 1: return public.returnMsg(False,'没有权限!')
        if len(args.username) < 2: return public.returnMsg(False,'用户名不能少于2位')
        if len(args.password) < 8: return public.returnMsg(False,'密码不能少于8位')
        salt="wuyitest"
        pdata = {
            "username": args.username.strip(),
            "phone":args.phone.strip(),
            "email":args.email.strip(),
            "password":public.md5(public.md5(public.md5(args.password.strip())+'_bt.cn')+salt),
            "salt":salt,
            #"password": public.password_salt(public.md5(args.password.strip()),username=args.username.strip())
        }
        #return (public.md5(public.md5(args.password.strip())+'_bt.cn'),public.md5(public.md5(public.md5(args.password.strip())+'_bt.cn')+salt))
        if(public.M('users').where('username=?',(pdata['username'],)).count()):
            return public.returnMsg(False,'指定用户名已存在!')
        
        if(public.M('users').insert(pdata)):
            uid=public.M('users').where('username=?',(pdata['username'],)).field('id').select()[0]['id']
            sql="INSERT INTO auth (uid)  VALUES ({})".format(uid)
            if not self.__M_int_up_del(sql):
                return public.returnMsg(False,'创建新用户{}异常，请删除后重新创建!'.format(pdata['username']))
            public.WriteLog('用户管理','创建新用户{}'.format(pdata['username']))
            return public.returnMsg(True,'创建新用户{}成功!'.format(pdata['username']))
        return public.returnMsg(False,'创建新用户失败!') #{"status": true, "msg": "创建新用户admin成功!"}
    # 删除用户
    def remove_user(self,args):
        if session['uid'] != 1: return public.returnMsg(False,'没有权限!')
        if int(args.id) == 1: return public.returnMsg(False,'不能删除初始默认用户!')
        username = public.M('users').where('id=?',(args.id,)).getField('username')
        if not username: return public.returnMsg(False,'指定用户不存在!')
        if(public.M('users').where('id=?',(args.id,)).delete()):
            sql="DELETE from auth where uid={}".format(args.id)
            if not self.__M_int_up_del(sql):
                return public.returnMsg(False,'用户删除存在异常~ 但不影响正常使用')
            public.WriteLog('用户管理','删除用户[{}]'.format(username))
            return public.returnMsg(True,'删除用户{}成功!'.format(username))
        return public.returnMsg(False,'用户删除失败!')

    # 修改用户
    def modify_user(self,args):
        if session['uid'] != 1: return public.returnMsg(False,'没有权限!')
        username = public.M('users').where('id=?',(args.id,)).getField('username')
        pdata = {}
        if 'username' in args:
            if len(args.username) < 2: return public.returnMsg(False,'用户名不能少于2位')
            pdata['username'] = args.username.strip()
        if 'phone' in args:
            #if len(args.phone) < 2: return public.returnMsg(False,'输入正确手机号')
            pdata['phone'] = args.phone.strip()
        if 'email' in args:
            #if len(args.username) < 2: return public.returnMsg(False,'输入正确邮箱')
            pdata['email'] = args.email.strip()
        if 'password' in args:
            if args.password:
                if len(args.password) < 8: return public.returnMsg(False,'密码不能少于8位')
                pdata['password'] = public.password_salt(public.md5(args.password.strip()),username=username)
        if(public.M('users').where('id=?',(args.id,)).update(pdata)):
            public.WriteLog('用户管理',"编辑用户{}".format(username))
            return public.returnMsg(True,'修改成功!')
        return public.returnMsg(False,'没有提交修改!')
    # 用户权限获取
    def auth_user(self,args):
        if session['uid'] != 1: return public.returnMsg(False,'没有权限!')
        count=self.__M_s("select auth from auth where uid = {}".format(args.id))[0][0]
        return count.split("|")
    # 用户权限设置
    def modify_auth(self,args):
        if session['uid'] != 1: return public.returnMsg(False,'没有权限!')
        if int(args.id) == 1: return public.returnMsg(False,'超级管理员账号，无法修改!')
        self.auth_uid()
        username = public.M('users').where('id=?',(args.id,)).getField('username')
        if 'url' in args:
            sql="UPDATE auth set auth = '{}' where uid={}".format(args.url.strip().strip( '|' ),args.id)
            if not self.__M_int_up_del(sql):
                return public.returnMsg(False,'权限更新存在异常')
            public.WriteLog('用户管理','更新用户[{}]权限'.format(username))
            return public.returnMsg(True,'用户[{}]权限更新成功'.format(username))
        return public.returnMsg(False,'没有提交修改!')
    # 权限表用户效验
    def auth_uid(self):
        uidlist=public.M('users').field('id').select()
        a=[]
        for uid in uidlist:
            count=self.__M_s("select count(*) from auth where uid = {}".format(uid['id']))[0][0]
            if not count:
                sql="INSERT INTO auth (uid)  VALUES ({})".format(uid['id'])
                if not self.__M_int_up_del(sql):
                    return public.returnMsg(False,'权限检测存在异常')

    def get_logs(self,args):
        #处理前端传过来的参数
        if not 'p' in args: args.p = 1
        if not 'rows' in args: args.rows = 12
        if not 'callback' in args: args.callback = ''
        args.p = int(args.p)
        args.rows = int(args.rows)

        #取日志总行数
        count = public.M('logs').count()

        #获取分页数据
        page_data = public.get_page(count,args.p,args.rows,args.callback)

        #获取当前页的数据列表
        log_list = public.M('logs').order('id desc').limit(page_data['shift'] + ',' + page_data['row']).field('id,type,log,addtime').select()
        
        #返回数据到前端
        return {'data': log_list,'page':page_data['page'] }
    def ransalt(self,num):
        import random
        # 猜猜变量名为啥叫 H
        H = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789'

        salt = ''
        for i in range(num):
            salt += random.choice(H)

        return salt
    #取数据库对象
    def __GetConn(self): 
        try:
            if self.__DB_CONN == None:
                self.__DB_CONN = sqlite3.connect(self.__DB_FILE)
                self.__DB_CONN.text_factory = str
        except Exception as ex:
            return "error: " + str(ex)
    #数据库 插入 更新 删除
    def __M_int_up_del(self,sql):
        self.__GetConn()
        S=self.__DB_CONN.cursor()
        S.execute(sql)
        self.__DB_CONN.commit()
        num=self.__DB_CONN.total_changes
        # self.__DB_CONN.close()
        return num
    # 数据库 查询
    def __M_s(self,sql):
        self.__GetConn()
        S=self.__DB_CONN.cursor()
        cursors = S.execute(sql)
        data=[]
        for row in cursors:
            data.append(row)
        # self.__DB_CONN.close()
        return data
    # 重启面包
    def re_server(self,args):
        public.restart_panel()
        return public.returnMsg(True,'重启成功') 
    #读取配置项(插件自身的配置文件)
    #@param key 取指定配置项，若不传则取所有配置[可选]
    #@param force 强制从文件重新读取配置项[可选]
    def __get_config(self,key=None,force=False):
        #判断是否从文件读取配置
        if not self.__config or force:
            config_file = self.__plugin_path + 'config.json'
            if not os.path.exists(config_file): return None
            f_body = public.ReadFile(config_file)
            if not f_body: return None
            self.__config = json.loads(f_body)

        #取指定配置项
        if key:
            if key in self.__config: return self.__config[key]
            return None
        return self.__config

    #设置配置项(插件自身的配置文件)
    #@param key 要被修改或添加的配置项[可选]
    #@param value 配置值[可选]
    def __set_config(self,key=None,value=None):
        #是否需要初始化配置项
        if not self.__config: self.__config = {}

        #是否需要设置配置值
        if key:
            self.__config[key] = value

        #写入到配置文件
        config_file = self.__plugin_path + 'config.json'
        public.WriteFile(config_file,json.dumps(self.__config))
        return True

if __name__ == "__main__":
    chk = sys.argv[1]
    if chk =='check':
        user_auth=user_auth_main()
        user_auth.auth_uid()